Attribute VB_Name = "modGlobals"
Option Explicit
Private Const MODULE_NAME = "modGlobals"

Public Const APP_CAPTION = "proxyper Log Analyzer"
Public Const REG_APP_NAME = "proxyper Log Analyzer"
Public Const REG_COMMON_SECTION = "Common"
Public Const REG_LV_SECTION = "ListView"
Public Const REG_DETAILS_SECTION = "Details"
Public Const ALL_CLIENTS = "<All-clients>"
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208
Public Const WM_MBUTTONDBLCLK = &H209
Public Const WM_KEYDOWN = &H100
Public Const MAXGETHOSTSTRUCT = 1024
Public Const HEAP_ZERO_MEMORY = &H8
Public Const ERR_NUM = "Error: 0x"

Public g_lTimeZone As Long
Public g_lRefeshRate As Long
Public g_cClients As Dictionary
Public g_cPendingResolutions As New Collection
Public g_cResolutions As New Collection
Public g_bResolve As Boolean
Public g_bWebStats As Boolean
Public g_lWebRefeshRate As Long
Public g_bWebLocal As Boolean
Public g_sWebFolder As String
Public g_sWebFTPServer As String
Public g_sWebFTPUser As String
Public g_sWebFTPPassword As String

Public Const AF_INET = 2 '/* internetwork: UDP, TCP, etc. */
Public Const AF_NETBIOS = 17 '/* NetBios-style addresses */

Public Declare Function WSAStartup Lib "wsock32.dll" (ByVal Version As Long, Data As Any) As Long
Public Declare Function GetHostByAddr Lib "wsock32.dll" Alias "gethostbyaddr" (bAddrArray As Any, ByVal TheLen As Long, ByVal TheType As Long) As Long
Public Declare Function WSAAsyncGetHostByAddr Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, bAddrArray As Any, ByVal TheLen As Long, ByVal TheType As Long, bBuf As Any, ByVal lBufLen As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function PathCompactPath Lib "shlwapi.dll" Alias "PathCompactPathA" (ByVal hDC As Long, ByVal Path As String, ByVal dx As Long) As Long
Public Declare Function GetProcessHeap Lib "kernel32" () As Long
Public Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long

Private m_bWSAStartup As Boolean

Public Function Resolve(sHost As String) As String
    Dim bArray(3) As Byte, v, lPtr As Long, sName As String
    Dim sBuffer As String, hPtr As Long, sDump As String
    On Error GoTo EH
    If g_bResolve And sHost Like "*.*.*.*" Then
        If m_bWSAStartup = False Then
            sDump = String(5000, 0)
            WSAStartup &H101, ByVal sDump
            m_bWSAStartup = True
        End If
        On Error Resume Next
        Resolve = g_cResolutions(sHost)
        If Err.Number <> 0 Then
            g_cResolutions.Add sHost, sHost
            v = Split(sHost, ".")
            bArray(0) = v(0): bArray(1) = v(1)
            bArray(2) = v(2): bArray(3) = v(3)
            hPtr = HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, MAXGETHOSTSTRUCT)
            If hPtr <> 0 Then
                lPtr = WSAAsyncGetHostByAddr(frmHidden.hWnd, WM_KEYDOWN, bArray(0), 4, AF_NETBIOS, ByVal hPtr, MAXGETHOSTSTRUCT)
                g_cPendingResolutions.Add Array(sHost, hPtr), Hex(lPtr)
            End If
            Resolve = sHost
        End If
    Else
        Resolve = sHost
    End If
    Exit Function
EH:
    Err.Raise Err.Number, Err.Source, MODULE_NAME & ":Resolve" & Err.Description
End Function

Public Function GetCurrentDate() As String
    On Error GoTo EH
    GetCurrentDate = Format(Month(Date), "00") & "/" & _
                Format(Day(Date), "00") & "/" & _
                Right(Year(Date), 2)
    Exit Function
EH:
    Err.Raise Err.Number, Err.Source, MODULE_NAME & ":GetCurrentDate" & Err.Description
End Function

Public Sub ReadNames(sFile As String)
    Dim iFile As Integer, sData As String, lI As Long
    Dim v, vRow
    On Error GoTo EH
    '--- clear resolved names
    Set g_cResolutions = New Collection
    iFile = FreeFile
    Open sFile For Binary As #iFile
    sData = String(LOF(iFile), 0)
    Get iFile, , sData
    v = Split(sData, vbCrLf)
    For lI = 0 To UBound(v)
        sData = Trim(v(lI))
        While InStr(sData, "  ") > 0
            sData = Replace(sData, "  ", " ")
        Wend
        vRow = Split(sData, " ")
        If UBound(vRow) >= 1 Then
            g_cResolutions.Add CStr(vRow(1)), CStr(vRow(0))
        End If
    Next
EH:
    Close #iFile
End Sub
